/**
 * @author TIBCO Software Inc.
 * Copyright (c) 2015-2016 TIBCO Software, Inc. All Rights Reserved.
 */
var app = angular.module('MyWork', ['TibcoFramework']);
// NOTE: After cloning the app, if you want to use your own L10N bundle,
// uncomment the following code and pass the right app name
// app.run(['BPMTranslationServiceConfig', function(BPMTranslationServiceConfig) {
// 	BPMTranslationServiceConfig.registerApp("MyApp_name_here", null);
// }]);

// Config Theme
app.config(["tibThemingProvider", function(tibThemingProvider) {
   
    tibThemingProvider.theme('default') // Overwriting existing 'default' theme with the following custom theme.
        .primaryPalette('customPaletteName-primary') // add custom primary palette
        .accentPalette('customPaletteName-accent')  // add custom accent palette
        .warnPalette('customPaletteName-warn') // add custom warn palette
        .backgroundPalette('customPaletteName-background'); // add custom background palette

    // the first step that add the new theme palette name, and add the color follow the comment
    // if you want to add the new theme, copy the following code, and change the color
    tibThemingProvider.definePalette('customPaletteName-primary', {
        '50': '#6ac3ce',   // for user profile background
        '100': '02579A',  // for business actions button background
        '200': 'ef9a9a',  // for business actions list
        '300': '6AC3CE',  // for menu container background
        '400': '008DA1',  // for no background font color, the icon color, the filter border color,
                          // the card selected color, the bottom sheet icons and the font color
        '500': 'F7FDFD',  // menu hover
        '600': 'E0F8FA',  // menu selected
        '700': 'F0F1F5',  //detail nav background
        '800': '7F7A7C',  //detail nav color
        '900': 'F0F1F5',  //table selected background
        'A100': 'E0F8FA', //the card show buttons background, the more-info font color
        'A200': '6AC3CE', //the card box shadow
        'A400': 'ff1744',
        'A700': 'd50000',
        'contrastDefaultColor': 'light',    // whether, by default, text (contrast)
                                            // on this palette should be dark or light
        'contrastDarkColors': ['50', '100', //hues which contrast should be 'dark' by default
            '200', '300', '400', 'A100', 'A200'],
        'contrastLightColors': undefined    // could also specify this if default was 'dark'
    });
    tibThemingProvider.definePalette('customPaletteName-accent', {
        '50': '7F7F7F',   // for user profile background
        '100': '02579A',  // for business actions button background
        '200': 'ef9a9a',  // for business actions list
        '300': '6AC3CE',  // for menu container background
        '400': '008DA1',  // for no background font color, the icon color, the filter border color,
                          // the card selected color, the bottom sheet icons and the font color
        '500': 'F7FDFD',  // menu hover
        '600': 'E0F8FA',  // menu selected
        '700': 'F0F1F5',  //detail nav background
        '800': '7F7A7C',  //detail nav color
        '900': 'F0F1F5',  //table selected background
        'A100': 'E0F8FA', //the card show buttons background, the more-info font color
        'A200': '6AC3CE', //the card box shadow
        'A400': 'ff1744',
        'A700': 'd50000',
        'contrastDefaultColor': 'light',    // whether, by default, text (contrast)
                                            // on this palette should be dark or light
        'contrastDarkColors': ['50', '100', //hues which contrast should be 'dark' by default
            '200', '300', '400', 'A100', 'A200'],
        'contrastLightColors': undefined    // could also specify this if default was 'dark'
    });
    tibThemingProvider.definePalette('customPaletteName-warn', {
        '50': '7F7F7F',   // for user profile background
        '100': '02579A',  // for business actions button background
        '200': 'ef9a9a',  // for business actions list
        '300': '6AC3CE',  // for menu container background
        '400': '008DA1',  // for no background font color, the icon color, the filter border color,
                          // the card selected color, the bottom sheet icons and the font color
        '500': 'F7FDFD',  // menu hover
        '600': 'E0F8FA',  // menu selected
        '700': 'F0F1F5',  //detail nav background
        '800': '7F7A7C',  //detail nav color
        '900': 'F0F1F5',  //table selected background
        'A100': 'E0F8FA', //the card show buttons background, the more-info font color
        'A200': '6AC3CE', //the card box shadow
        'A400': 'ff1744',
        'A700': 'd50000',
        'contrastDefaultColor': 'light',    // whether, by default, text (contrast)
                                            // on this palette should be dark or light
        'contrastDarkColors': ['50', '100', //hues which contrast should be 'dark' by default
            '200', '300', '400', 'A100', 'A200'],
        'contrastLightColors': undefined    // could also specify this if default was 'dark'
    });
    tibThemingProvider.definePalette('customPaletteName-background', {
        '50': '7F7F7F',   // for user profile background
        '100': '02579A',  // for business actions button background
        '200': 'ef9a9a',  // for business actions list
        '300': '6AC3CE',  // for menu container background
        '400': '008DA1',  // for no background font color, the icon color, the filter border color,
                          // the card selected color, the bottom sheet icons and the font color
        '500': 'F7FDFD',  // menu hover
        '600': 'E0F8FA',  // menu selected
        '700': 'F0F1F5',  //detail nav background
        '800': '7F7A7C',  //detail nav color
        '900': 'F0F1F5',  //table selected background
        'A100': 'E0F8FA', //the card show buttons background, the more-info font color
        'A200': '6AC3CE', //the card box shadow
        'A400': 'ff1744',
        'A700': 'd50000',
        'contrastDefaultColor': 'light',    // whether, by default, text (contrast)
                                            // on this palette should be dark or light
        'contrastDarkColors': ['50', '100', //hues which contrast should be 'dark' by default
            '200', '300', '400', 'A100', 'A200'],
        'contrastLightColors': undefined    // could also specify this if default was 'dark'
    });
  
    tibThemingProvider.alwaysWatchTheme(true);
    
}]);

app.controller('MyWorkCtrl', function ($scope, $timeout, $document, $rootScope, bpmWorkListFactory, BPMLoginService) {
	  $scope.theme = 'default';

    //set the left nav open when the page load
    $scope.flagLeftnav = true;

    $document.on('click', function(e) {
        if (e.target.className.indexOf('menu-button') > -1) return;
        $rootScope.$broadcast('pageClicked', 'hide menu');
    });

    // config the appId for localization.
    // It defines that the translation id starts with the prefix 'tcf'. Look at the templates for usage.
    $rootScope.appConfig = {
        appId: 'tcf'
    };

    // config the priority, you can not change the text, you can remove but don't change the word, you can change the number
    $rootScope.setPriorityLevel = {
        LOW: [0,30],
        MEDIUM: [30,60],
        HIGH: [60,80],
        CRITICAL: [80,100]
    };

    $scope.sidenavData = {
        "user": {
            "img":'images/user_profile.png',
            "name":'user@tibco.com',
            "more":'userMore'
        },
        "currActionsCount": 44,
        "hideLeftMenu": false,
        // what is been shown in the main area content: form vs other
        "main_content": ""
    }

    $scope.isMainContentShowingForm = function() {
		    return ($scope.main_content == 'form');
	  };

	  $scope.formDiv = "formAddDiv";

	  $scope.setMainContent = function(content) {
		    $scope.main_content = content;
	  }

    $scope.toggleLeftMenu = function(expandActions) {
        if (expandActions) {
            $timeout(function() {
                $scope.workViews.hideLeftMenu = true;
            }, 500);
        } else {
            $scope.workViews.hideLeftMenu = false;
        }
    };
    //above is the nav-menu data

    function makeTableResponsive() {
        window.onresize = function() {
            var height = parseInt($('.work-list-content').height());
            var tableAreaHeight = height - 42;

            var tableInitHeight = parseInt($('.work-items-grid').attr('init-height'));
            if (!tableInitHeight) return;

            if (tableAreaHeight < tableInitHeight) {
                $timeout(function() {
                    $scope.$broadcast('changeHeight', {height: tableAreaHeight});
                });
            }
        };
    }

    makeTableResponsive();

    //bpm-work-views
    $scope.menuItemSelect = function(item){
        if (item.name == "WorkList") {
			$scope.workList.workViewId = null;
			$scope.workList.viewName = item.name;
		} else {
			$scope.workList.workViewId = item.workViewID;
			$scope.workList.viewName = item.name;
		}
    };
    // for new demo data
    $scope.workViews = {
        "start":"0",
        "pageSize":"100",
        "hideLeftMenu": false,
        "workListViews":[

        ]
    };
    $scope.workList = {
        "start":"0",
        "pageSize":"10",
        "formDiv":'formDiv',
        "startPosition":0,
        "endPosition":9,
        "totalItems": 10,
        // workViewId should be a number, use guid instead
        // "workViewId":'a',
        "workItems":[
        ]
    };
	// This is the right place to have this, as $scope.workList should be
	// available when getExtendedUserInfo() immediately notifies the onSuccess callback
	BPMLoginService.getExtendedUserInfo({
		onSuccess : function(userInfo) {
			$timeout(function() {
				$scope.workList.guid = userInfo.guid;
				$scope.sidenavData.user.name = userInfo.name;
			}, 0);
		}
    });
});
